//+------------------------------------------------------------------+
//|                                         Nusa_TMACen_Envelope.mq4 |
//|                                                     No_Risk@2014 |
//|                                    Modified from TMAcentered.mq4 |
//|                                              By mladen forex-tsd |
//+------------------------------------------------------------------+
#property copyright "TMAcentered by mladen"
#property link      "www.forex-tsd.com"
#property description "Nusa TMA Centered + Envelope"
#property description "By No_risk@2014"

#property indicator_chart_window
#property indicator_buffers 3

//
//
//
//
//
//---- eksternal input
extern	string	Readme1	      = "--== TMAPeriod Input ==--",
						Readme2	      = "5M 15M 30M 1H 2H 3H 4H 6H 8H 12H 20H 1D",
						Readme3	      = "2D 3D 4D 1W 2W 3W 1MH 2MH 3MH 4MH 6MH 1Y",
						TMAPeriod       = "1D";
						
extern	string   Readme4        = "--== Applied_Price ==--",
						Readme5        = "0=Close 1=Open 2=High 3=Low",
						Readme6        = "4=Median(HL/2) 5=Typical(HLC/3) 6=Weighted(HLCC/4)";

extern int        Applied_Price  = 6;

extern double		EnvDeviation  = 0.25;
						
extern bool       ShowPrice      = true;

extern color      Midcolor       = DodgerBlue,
                  UpperEnvcolor  = Red,
                  LowerEnvcolor  = Green;

double UpEnv[];
double LoEnv[];
double MidBuf[];
int HalfLength, Per;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int init()
{
   if(TMAPeriod == "1Y")			{ Per = 345600/Period(); }
	else if(TMAPeriod == "6MH")	{ Per = 172800/Period(); }
	else if(TMAPeriod == "4MH")	{ Per = 115200/Period(); }
	else if(TMAPeriod == "3MH")	{ Per = 86400/Period(); }
	else if(TMAPeriod == "2MH")	{ Per = 57600/Period(); }
	else if(TMAPeriod == "1MH")	{ Per = 28800/Period(); }
	else if(TMAPeriod == "3W")	   { Per = 21600/Period(); }
	else if(TMAPeriod == "2W")	   { Per = 14400/Period(); }
	else if(TMAPeriod == "1W")	   { Per = 7200/Period(); }
	else if(TMAPeriod == "4D")	   { Per = 5760/Period(); }
	else if(TMAPeriod == "3D")	   { Per = 4320/Period(); }
	else if(TMAPeriod == "2D")	   { Per = 2880/Period(); }
	else if(TMAPeriod == "1D")	   { Per = 1440/Period(); }
	else if(TMAPeriod == "20H")	{ Per = 1200/Period(); }
	else if(TMAPeriod == "12H")	{ Per = 720/Period(); }
	else if(TMAPeriod == "8H")	   { Per = 480/Period(); }
	else if(TMAPeriod == "6H")	   { Per = 360/Period(); }
	else if(TMAPeriod == "4H")	   { Per = 240/Period(); }
	else if(TMAPeriod == "3H")	   { Per = 180/Period(); }
	else if(TMAPeriod == "2H")	   { Per = 120/Period(); }
	else if(TMAPeriod == "1H")	   { Per = 60/Period(); }
	else if(TMAPeriod == "30M")	{ Per = 30/Period(); }
	else if(TMAPeriod == "15M")	{ Per = 15/Period(); }
	else if(TMAPeriod == "5M")	   { Per = 5/Period(); }
   
   HalfLength = Per/2;
   HalfLength=MathMax(HalfLength,1);
   
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE,STYLE_DASHDOTDOT,1,UpperEnvcolor);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,1,Midcolor);
   SetIndexStyle(2,DRAW_LINE,STYLE_DASHDOTDOT,1,LowerEnvcolor);

//---- indicator short name
   IndicatorShortName("Nusa_TMACen_Env_("+TMAPeriod+")");
   SetIndexLabel(0,"Nusa_UpEnv_("+EnvDeviation+")_("+TMAPeriod+")");
   SetIndexLabel(1,"Nusa_MidEnv_("+TMAPeriod+")");
   SetIndexLabel(2,"Nusa_LoEnv_("+EnvDeviation+")_("+TMAPeriod+")");

   
   SetIndexBuffer(0,UpEnv);  
   SetIndexBuffer(1,MidBuf); 
   SetIndexBuffer(2,LoEnv); 
   
   SetIndexDrawBegin(0,HalfLength);
   SetIndexDrawBegin(1,HalfLength);
   SetIndexDrawBegin(2,HalfLength);

   return(0);
}
int deinit() 
{ 
   ObjectDelete("Price_UpEnv_("+TMAPeriod+")");
   ObjectDelete("Price_MidEnv_("+TMAPeriod+")");
   ObjectDelete("Price_LoEnv_("+TMAPeriod+")");

   return(0); 
}




//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,j,k,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars+HalfLength,Bars-1);

   //
   //
   //
   //
   //
   
   for (i=limit;i>=0;i--)
   {
      double sum  = (HalfLength+1)*iMA(NULL,0,1,0,MODE_SMA,Applied_Price,i);
      double sumw = (HalfLength+1);
      for(j=1, k=HalfLength; j<=HalfLength; j++, k--)
      {
         sum  += k*iMA(NULL,0,1,0,MODE_SMA,Applied_Price,i+j);
         sumw += k;
         if (j<=i)
         {
            sum  += k*iMA(NULL,0,1,0,MODE_SMA,Applied_Price,i-j);
            sumw += k;
         }
      }
      MidBuf[i] = sum/sumw;
      UpEnv[i] = (1+EnvDeviation/100)*MidBuf[i];
      LoEnv[i] = (1-EnvDeviation/100)*MidBuf[i];
   
   }
   
   if (ShowPrice==true)
   {
   string Pricelabel1 = "Price_UpEnv_("+TMAPeriod+")";
   ObjectCreate( Pricelabel1, OBJ_ARROW, 0, 0, 0 );
   ObjectSet( Pricelabel1, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
   ObjectSet( Pricelabel1, OBJPROP_COLOR, UpperEnvcolor);
   ObjectSet( Pricelabel1, OBJPROP_TIME1, Time[0]);
   ObjectSet( Pricelabel1, OBJPROP_PRICE1, UpEnv[0]);
   
   string Pricelabel2 = "Price_MidEnv_("+TMAPeriod+")";
   ObjectCreate( Pricelabel2, OBJ_ARROW, 0, 0, 0 );
   ObjectSet( Pricelabel2, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
   ObjectSet( Pricelabel2, OBJPROP_COLOR, Midcolor);
   ObjectSet( Pricelabel2, OBJPROP_TIME1, Time[0]);
   ObjectSet( Pricelabel2, OBJPROP_PRICE1, MidBuf[0]);

   string Pricelabel3 = "Price_LoEnv_("+TMAPeriod+")";
   ObjectCreate( Pricelabel3, OBJ_ARROW, 0, 0, 0 );
   ObjectSet( Pricelabel3, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
   ObjectSet( Pricelabel3, OBJPROP_COLOR, LowerEnvcolor);
   ObjectSet( Pricelabel3, OBJPROP_TIME1, Time[0]);
   ObjectSet( Pricelabel3, OBJPROP_PRICE1, LoEnv[0]);
   
   }

   return(0);
}